indexing

	description:

		"Common code to deal with errors."

	library: "Gobo Eiffel Pipework Library"
	copyright: "Copyright (c) 2002, Berend de Boer and others"
	license: "Eiffel Forum License v1 (see forum.txt)"
	date: "$Date: $"
	revision: "$Revision: $"

class

	PW_LAST_RESULT

feature -- Error code

	diagnostic_code: INTEGER
			-- Code related to last executed command.
			-- What it exactly means is system dependent. The value might
			-- be useful for some higher level error handling code.

	diagnostic_message: STRING
			-- Any message that explains `last_result'.

feature -- Error interpretation

	is_ok: BOOLEAN is
			-- Interprets `last_result' into ok or failure.
			-- Default is to treat any non-zero code as an error.
		do
			Result := diagnostic_code = 0
		end

feature -- Comands

	clear_error is
			-- Clear error code, such that `is_ok'.
		do
			diagnostic_code := 0
			diagnostic_message := Void
		ensure
			no_error: is_ok
		end

end
