indexing

	description: "Turns individual characters in strings to INTEGER_8 output."

	library: "Gobo Eiffel Pipework Library"
	copyright: "Copyright (c) 2003, Berend de Boer and others"
	license: "Eiffel Forum License v2 (see forum.txt)"
	date: "$Date: $"
	revision: "$Revision: $"

class

	PW_STRING_TO_INTEGER_8

inherit

	PW_DESTINATION_WRITER [STRING]
		redefine
			drain,
			flush,
			put
		end

feature -- Connection management

	drain: PW_WRITER [INTEGER_8]
			-- Where we send our output.

feature -- Writer

	flush is
		do
			if is_connected then
				drain.flush
			end
		end

	put (v: STRING) is
			-- Write `v' to output stream.
		local
			i: INTEGER
			c: CHARACTER
		do
			from
				i := 1
			until
				i > v.count
			loop
				c := v.item (i)
				drain.put (c.code.to_integer_8)
				i := i + 1
			end
		end

end
