indexing

	description:

		"Obtain CHARACTERs from a STRING"

	library: "Gobo Eiffel Pipework Library"
	copyright: "Copyright (c) 2002, Simon Parker and others"
	license: "Eiffel Forum License v1 (see forum.txt)"
	date: "$Date: $"
	revision: "$Revision: $"

class

	PW_STRING_CHARACTER_SOURCE

inherit

	PW_SOURCE_READER [CHARACTER]
		redefine
			end_of_input,
			rewind,
			source
		end

creation

	make,
	connect

feature -- Status reports

	end_of_input: BOOLEAN is
			-- Are there no more items to read?
		do
			Result :=
				source /= Void and then last_read_at > source.count
		end

feature -- Reading

	last_item: CHARACTER
			-- The CHARACTER read by the last successful 'read'.

	rewind is
		do
			last_read_at := 0
		end

	read is
			-- Attempt to obtain an item from source and make it
			-- available in `last_read'.
		do
			last_read_at := last_read_at + 1
			if source.valid_index (last_read_at) then
				last_item := source.item (last_read_at)
			end
		end

feature -- Source and connection management

	source: STRING
			-- Where we get them from

feature {NONE} -- Implementation

	last_read_at: INTEGER

end
